Poor performance
04/23/2020 01:30 AM - Luke Murphey
Priority: Normal Due date:
Category: Estimated time: 0.00 hour
Target version: 4.0

Description

History

#1 - 04/23/2020 01:35 AM - Luke Murphey

| suspect that this is caused by excessive re-rending of the Reader view.

| also may want to debounce some of the calls: https:/stackoverflow.com/questions/23123138/perform-debounce-in-react-js

#2 - 04/29/2020 06:41 PM - Luke Murphey

Pain points:

e Searching the works list

#3 - 05/04/2020 08:02 PM - Luke Murphey
https://medium.com/@anuhosad/debouncing-events-with-react-b8c405¢33273

#4 - 05/04/2020 08:10 PM - Luke Murphey
Getting this error: https://github.com/babel/babel/issues/9849

Seems fixed by importing regeneratorRuntime

#5 - 05/04/2020 08:52 PM - Luke Murphey

| denounced the fetch call. This isn't the issue since | am filtering on the client side.

const fetchWorks = () => fetch (ENDPOINT_WORKS_LISTS());
const fetchWorksDebounced = AwesomeDebouncePromise (fetchWorks, 1500);

async loadInfo() {

try {
const response = await fetchWorksDebounced();
const works = await response.json();
this.setState ({ works });

} catch (e) {

this.setState ({
error: e.toString(),

i

| updated to filter onChange. This is better but a search for "josephus" is still slow.
https://stackoverflow.com/questions/23123138/perform-debounce-in-react-js
https://medium.com/@anuhosad/debouncing-events-with-react-b8c405c33273
https://github.com/babel/babel/issues/9849

#6 - 05/04/2020 09:18 PM - Luke Murphey

Tried building an index. This is still slow.

o https:/nikitahl.com/how-to-find-an-item-in-a-javascript-array/
o Says forLoop is best
e https://developer.mozilla.org/en-US/docs/Web/APl/Performance
o Performance measuring API
e hitps://www.andygup.net/fastest-way-to-find-an-item-in-a-javascript-array/
¢ https://andrewdupont.net/2006/05/18/javascript-associative-arrays-considered-harmful/
o Says to use an associative array
e https://koukia.ca/top-6-ways-to-search-for-a-string-in-javascript-and-performance-benchmarks-ce3e9b81ad31
o Regexes are faster but not by much
://hackernoon.com/3-javascript-performan
o For Loop and While is fast; Map is slow

e h -sh

#7 - 05/04/2020 11:03 PM - Luke Murphey
Obs:

e Searching took 3 ms according to console.time()

The Ul seems to hang; like CPU is held up

This seems to be a problem for the first render, but is better after the first slow search
Seeing tons of LazyLoad componentWillUnmount()

| see lots of commitNestedUnmounts() which each take 50ms

Qs:

¢ What is taking so long?
o searching takes 3ms
o rendering is not the problem either
¢ [Yes] Is CPU usage high?
o Two cores seem to hit 50% for a while
¢ [No] Does removing LazylLoad help?
o No
e Why is the first load so much faster?
¢ [Yes] Does reducing the number help much?
o Very much so
® [No] Does removing the handlers help?
° No
¢ [No] Is it better the the search matches few entries?
e Use https://react.semantic-ui.com/behaviors/visibility/
e Does rendering almost nothing help?
o Very much so
o lts the image that is causing the problem

Solns:

¢ [No] Keep rendered components in a list; don't re-render
o Performance seems no better
e Do the search on the server-side
o This would allow me to load related works easier too
¢ Use another component
o https://cmichel.io/lazy-load-images-with-react/
https://nikitahl.com/how-to-find-an-item-in-a-javascript-array/
https://developer.mozilla.org/en-US/docs/Web/API/Performance
https://www.andygup.net/fastest-way-to-find-an-item-in-a-javascript-array/
https://andrewdupont.net/2006/05/18/javascript-associative-arrays-considered-harmful/
https://koukia.ca/top-6-ways-to-search-for-a-string-in-javascript-and-performance-benchmarks-ce3e9b81ad31
https://react.semantic-ui.com/behaviors/visibility/
https://cmichel.io/lazy-load-images-with-react/

#8 - 05/05/2020 02:33 AM - Luke Murphey

- File index.jsx added

Attaching modified Reader/index.jsx

#9 - 05/17/2020 07:41 PM - Luke Murphey

| could have these load on infinite scroll with https://react.semantic-ui.com/behaviors/visibility/

#10 - 05/19/2020 06:54 AM - Luke Murphey
[Violation] Forced reflow while executing JavaScript took 16757ms

#11 - 05/24/2020 03:40 PM - Luke Murphey

The

Qs:

e |s there another callback that seems to work?

Solns:

e Use another call back

o onOnScreen: same
e Show the first few regardless

Refs:

e https://www.digitalocean.com/community/tutorials/react-components-viewport-react-visibility-sensor
#12 - 05/24/2020 03:40 PM - Luke Murphey
https://react.semantic-ui.com/behaviors/visibility/
https://www.digitalocean.com/community/tutorials/react-components-viewport-react-visibility-sensor

- Status changed from New to Closed

- % Done changed from 0 to 100

Files

index.jsx 4.27 KB 05/05/2020 Luke Murphey
